"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.languageServer = void 0;

var _clientJs = require("@open-rpc/client-js");

var _state = require("@codemirror/state");

var _view = require("@codemirror/view");

var _lint = require("@codemirror/lint");

var _tooltip = require("@codemirror/tooltip");

var _autocomplete = require("@codemirror/autocomplete");

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return; var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

// Generated by CoffeeScript 2.5.1
var LanguageServerPlugin, baseTheme, documentUri, _formatContents, languageId, offsetToPos, posToOffset, prefixMatch, rootUri, serverUri, toSet;

serverUri = _state.Facet.define({
  combine: function combine(values) {
    return values.reduce(function (_, v) {
      return v;
    }, '');
  }
});
rootUri = _state.Facet.define({
  combine: function combine(values) {
    return values.reduce(function (_, v) {
      return v;
    }, '');
  }
});
documentUri = _state.Facet.define({
  combine: function combine(values) {
    return values.reduce(function (_, v) {
      return v;
    }, '');
  }
});
languageId = _state.Facet.define({
  combine: function combine(values) {
    return values.reduce(function (_, v) {
      return v;
    }, '');
  }
});

LanguageServerPlugin = /*#__PURE__*/function () {
  function LanguageServerPlugin(view1) {
    var _this = this;

    _classCallCheck(this, LanguageServerPlugin);

    this.view = view1;
    this.rootUri = this.view.state.facet(rootUri);
    this.documentUri = this.view.state.facet(documentUri);
    this.languageId = this.view.state.facet(languageId);
    this.documentVersion = 0;
    this.promises = [];
    this.transport = new _clientJs.WebSocketTransport(this.view.state.facet(serverUri));
    this.requestManager = new _clientJs.RequestManager([this.transport]);
    this.client = new _clientJs.Client(this.requestManager);
    this.client.onNotification(function (data) {
      return _this.processNotification(data);
    });
    this.initialize({
      documentText: this.view.state.doc.toString()
    });
  }

  _createClass(LanguageServerPlugin, [{
    key: "update",
    value: function update(_ref) {
      var view = _ref.view,
          state = _ref.state,
          docChanged = _ref.docChanged;
      return null;
    }
  }, {
    key: "destroy",
    value: function destroy() {
      return this.client.close();
    }
  }, {
    key: "initialize",
    value: function initialize(_ref2) {
      var _this2 = this;

      var documentText = _ref2.documentText;
      var ref;

      if ((ref = this.client) != null) {
        ref.request({
          method: 'initialize',
          params: {
            capabilities: {
              textDocument: {
                hover: {
                  dynamicRegistration: true,
                  contentFormat: ['plaintext', 'markdown']
                },
                synchronization: {
                  dynamicRegistration: true,
                  willSave: false,
                  didSave: false,
                  willSaveWaitUntil: false
                },
                completion: {
                  dynamicRegistration: true,
                  completionItem: {
                    snippetSupport: false,
                    commitCharactersSupport: true,
                    documentationFormat: ['plaintext', 'markdown'],
                    deprecatedSupport: false,
                    preselectSupport: false
                  },
                  contextSupport: false
                },
                signatureHelp: {
                  dynamicRegistration: true,
                  signatureInformation: {
                    documentationFormat: ['plaintext', 'markdown']
                  }
                },
                declaration: {
                  dynamicRegistration: true,
                  linkSupport: true
                },
                definition: {
                  dynamicRegistration: true,
                  linkSupport: true
                },
                typeDefinition: {
                  dynamicRegistration: true,
                  linkSupport: true
                },
                implementation: {
                  dynamicRegistration: true,
                  linkSupport: true
                }
              },
              workspace: {
                didChangeConfiguration: {
                  dynamicRegistration: true
                }
              }
            },
            initializationOptions: null,
            processId: null,
            rootUri: this.rootUri,
            workspaceFolders: [{
              name: 'root',
              uri: this.rootUri
            }]
          }
        }).then(function (_ref3) {
          var capabilities = _ref3.capabilities,
              serverInfo = _ref3.serverInfo;
          var ref1, ref2;
          _this2.capabilities = capabilities;

          if ((ref1 = _this2.client) != null) {
            ref1.notify({
              method: 'initialized',
              params: {}
            });
          }

          if ((ref2 = _this2.client) != null) {
            ref2.notify({
              method: 'textDocument/didOpen',
              params: {
                textDocument: {
                  uri: _this2.documentUri,
                  languageId: _this2.languageId,
                  text: documentText,
                  version: _this2.documentVersion
                }
              }
            });
          }

          _this2.ready = true;

          if (_this2.sendOnReady) {
            _this2.sendOnReady = false;
            return _this2.sendChange({
              documentText: documentText
            });
          }
        });
      }
    }
  }, {
    key: "sendChange",
    value: function sendChange(_ref4) {
      var documentText = _ref4.documentText;
      var e, ref;

      if (!this.ready) {
        this.sendOnReady = true;
        return;
      }

      try {
        if ((ref = this.client) != null) {
          ref.notify({
            method: 'textDocument/didChange',
            params: {
              textDocument: {
                uri: this.documentUri,
                version: this.documentVersion++
              },
              contentChanges: [{
                text: documentText
              }]
            }
          });
        }
      } catch (error) {
        e = error;
        console.error(e);
      }
    }
  }, {
    key: "requestDiagnostics",
    value: function requestDiagnostics(view) {
      var _this3 = this;

      this.sendChange({
        documentText: view.state.doc.toString()
      });
      return new Promise(function (_fulfill, _reject) {
        _this3.promises.push({
          type: 'diagnostics',
          fulfill: function fulfill() {
            return _fulfill.apply(void 0, arguments);
          },
          reject: function reject() {
            return _reject.apply(void 0, arguments);
          }
        });
      });
    }
  }, {
    key: "requestHoverTooltip",
    value: function requestHoverTooltip(view, _ref5) {
      var _this4 = this;

      var line = _ref5.line,
          character = _ref5.character;
      var ref;

      if (!this.ready || !this.capabilities.hoverProvider) {
        return null;
      }

      this.sendChange({
        documentText: view.state.doc.toString()
      });

      if ((ref = this.client) != null) {
        ref.request({
          method: 'textDocument/hover',
          params: {
            textDocument: {
              uri: this.documentUri
            },
            position: {
              line: line,
              character: character
            }
          }
        }).then(function (result) {
          var contents, end, pos, range;

          if (!result) {
            _this4.view.dispatch({
              reconfigure: {
                hoverTooltip: []
              }
            });

            return;
          }

          contents = result.contents;
          range = result.range;
          pos = posToOffset(view.state.doc, {
            line: line,
            character: character
          });
          end = void 0;

          if (range) {
            pos = posToOffset(view.state.doc, range.start);
            end = posToOffset(view.state.doc, range.end);
          }

          _this4.view.dispatch({
            reconfigure: {
              hoverTooltip: _tooltip.showTooltip.of({
                pos: pos,
                end: end,
                create: function create(view) {
                  var el;
                  el = document.createElement('div');
                  el.textContent = _formatContents(contents);
                  return {
                    dom: el
                  };
                },
                style: 'documentation',
                above: true
              })
            }
          });
        });
      }

      return null;
    }
  }, {
    key: "requestCompletion",
    value: function requestCompletion(context, _ref6, _ref7) {
      var line = _ref6.line,
          character = _ref6.character;
      var triggerKind = _ref7.triggerKind,
          triggerCharacter = _ref7.triggerCharacter;
      var ref;

      if (!this.ready || !this.capabilities.completionProvider) {
        return null;
      }

      this.sendChange({
        documentText: context.state.doc.toString()
      });
      return (ref = this.client) != null ? ref.request({
        method: 'textDocument/completion',
        params: {
          textDocument: {
            uri: this.documentUri
          },
          position: {
            line: line,
            character: character
          },
          context: {
            triggerKind: triggerKind,
            triggerCharacter: triggerCharacter
          }
        }
      }).then(function (result) {
        var match, options, pos, span, token, word;

        if (!result) {
          return null;
        }

        options = result.items.map(function (_ref8) {
          var detail = _ref8.detail,
              label = _ref8.label,
              kind = _ref8.kind,
              textEdit = _ref8.textEdit,
              documentation = _ref8.documentation,
              sortText = _ref8.sortText,
              filterText = _ref8.filterText;
          var completion;
          completion = {
            label: label,
            detail: detail,
            apply: label,
            type: {
              1: 'text',
              2: 'method',
              3: 'function',
              // 4: Constructor
              // 5: Field
              6: 'variable',
              7: 'class',
              8: 'interface',
              // 9: Module
              10: 'property',
              // 11: Unit
              // 12: Value
              13: 'enum',
              14: 'keyword',
              // 15: Snippet
              // 16: Color
              // 17: File
              // 18: Reference
              // 19: Folder
              // 20: EnumMember
              21: 'constant'
            }[kind],
            sortText: label,
            filterText: label
          };

          if (textEdit) {
            completion.apply = textEdit.newText;
          }

          if (documentation) {
            completion.info = _formatContents(documentation);
          }

          if (sortText) {
            completion.sortText = sortText;
          }

          if (filterText) {
            completion.filterText = filterText;
          }

          return completion;
        });

        var _prefixMatch = prefixMatch(options);

        var _prefixMatch2 = _slicedToArray(_prefixMatch, 2);

        span = _prefixMatch2[0];
        match = _prefixMatch2[1];
        token = context.matchBefore(match);
        pos = context.pos;

        if (token) {
          pos = token.from;
          word = token.text.toLowerCase();

          if (/^\w+$/.test(word)) {
            options = options.filter(function (_ref9) {
              var filterText = _ref9.filterText;
              return filterText.toLowerCase().indexOf(word) === 0;
            });
            options = options.sort(function (a, b) {
              switch (true) {
                case a.apply.indexOf(token.text) === 0 && b.apply.indexOf(token.text) !== 0:
                  return -1;

                case a.apply.indexOf(token.text) !== 0 && b.apply.indexOf(token.text) === 0:
                  return 1;

                default:
                  return 0;
              }
            });
          }
        }

        return {
          'from': pos,
          options: options
        };
      }) : void 0;
    }
  }, {
    key: "processNotification",
    value: function processNotification(_ref10) {
      var method = _ref10.method;
      var e;

      try {
        switch (method) {
          case 'textDocument/publishDiagnostics':
            this.processDiagnostics.apply(this, arguments);
        }
      } catch (error) {
        e = error;
        return console.error(e);
      }
    }
  }, {
    key: "processDiagnostics",
    value: function processDiagnostics(_ref11) {
      var _this5 = this;

      var params = _ref11.params;
      var annotations, p; // if @documentVersion isnt @params.version
      // 	return

      annotations = params.diagnostics.map(function (_ref12) {
        var range = _ref12.range,
            message = _ref12.message,
            severity = _ref12.severity;
        return {
          'from': posToOffset(_this5.view.state.doc, range.start),
          to: posToOffset(_this5.view.state.doc, range.end),
          severity: {
            1: 'error',
            2: 'warning',
            3: 'info',
            4: 'info'
          }[severity],
          message: message
        };
      });
      annotations.sort(function (a, b) {
        switch (true) {
          case a.from < b.from:
            return -1;

          case a.from > b.from:
            return 1;

          default:
            return 0;
        }
      });

      this.promises = function () {
        var j, len, ref, results;
        ref = this.promises;
        results = [];

        for (j = 0, len = ref.length; j < len; j++) {
          p = ref[j];

          if (p.type === 'diagnostics') {
            p.fulfill(annotations);
            continue;
          }

          results.push(p);
        }

        return results;
      }.call(this);
    }
  }, {
    key: "clearTooltip",
    value: function clearTooltip() {
      return this.view.dispatch({
        reconfigure: {
          hoverTooltip: []
        }
      });
    }
  }]);

  return LanguageServerPlugin;
}();

var languageServer = function languageServer(options) {
  var plugin;
  plugin = null;
  return [serverUri.of(options.serverUri), rootUri.of(options.rootUri), documentUri.of(options.documentUri), languageId.of(options.languageId), _view.ViewPlugin.define(function (view) {
    plugin = new LanguageServerPlugin(view);
    return plugin;
  }, {
    eventHandlers: {
      keyup: function keyup() {
        return this.clearTooltip();
      },
      click: function click() {
        return this.clearTooltip();
      }
    }
  }), (0, _lint.linter)(function (view) {
    return plugin != null ? plugin.requestDiagnostics(view) : void 0;
  }), (0, _tooltip.hoverTooltip)(function (view, pos, side) {
    return plugin != null ? plugin.requestHoverTooltip(view, offsetToPos(view.state.doc, pos)) : void 0;
  }), (0, _autocomplete.autocompletion)({
    override: [function (context) {
      var explicit, line, pos, ref, ref1, ref2, state, trigChar, trigKind;

      if (plugin == null) {
        return null;
      }

      state = context.state;
      pos = context.pos;
      explicit = context.explicit;
      line = state.doc.lineAt(pos);
      trigKind = 1; // Invoked

      trigChar = void 0;

      if (!explicit && ((ref = plugin.capabilities) != null ? (ref1 = ref.completionProvider) != null ? (ref2 = ref1.triggerCharacters) != null ? ref2.indexOf(line.text[pos - line.from - 1]) : void 0 : void 0 : void 0) >= 0) {
        trigKind = 2; // TriggerCharacter

        trigChar = line.text[pos - line.from - 1];
      }

      if (trigKind === 1 && !context.matchBefore(/\w+$/)) {
        return null;
      }

      return plugin.requestCompletion(context, offsetToPos(state.doc, pos), {
        triggerKind: trigKind,
        triggerCharacter: trigChar
      });
    }]
  }), baseTheme];
};

exports.languageServer = languageServer;

posToOffset = function posToOffset(doc, pos) {
  return doc.line(pos.line + 1).from + pos.character;
};

offsetToPos = function offsetToPos(doc, offset) {
  var line;
  line = doc.lineAt(offset);
  return {
    line: line.number - 1,
    character: offset - line.from
  };
};

_formatContents = function formatContents(contents) {
  var c, j, len, text;

  if (Array.isArray(contents)) {
    text = '';

    for (j = 0, len = contents.length; j < len; j++) {
      c = contents[j];
      text += _formatContents(c) + '\n\n';
    }

    return text;
  } else if (typeof contents === 'string') {
    return contents;
  } else {
    return contents.value;
  }
};

toSet = function toSet(chars) {
  var flat, preamble, words;
  preamble = "";
  flat = Object.keys(chars).join('');
  words = /\w/.test(flat);

  if (words) {
    preamble += "\\w";
    flat = flat.replace(/\w/g, '');
  }

  return "[".concat(preamble).concat(flat.replace(/[^\w\s]/g, '\\$&'), "]");
};

prefixMatch = function prefixMatch(options) {
  var apply, first, i, j, k, len, ref, rest, source;
  first = {};
  rest = {};

  for (j = 0, len = options.length; j < len; j++) {
    apply = options[j].apply;
    first[apply[0]] = true;

    for (i = k = 1, ref = apply.length; 1 <= ref ? k < ref : k > ref; i = 1 <= ref ? ++k : --k) {
      rest[apply[i]] = true;
    }
  }

  source = toSet(first) + toSet(rest) + "*$";
  return [new RegExp("^" + source), new RegExp(source)];
};

baseTheme = _view.EditorView.baseTheme({
  '$tooltip.documentation': {
    display: 'block',
    marginLeft: '0',
    padding: '3px 6px 3px 8px',
    borderLeft: '5px solid #999',
    whiteSpace: 'pre'
  },
  '$tooltip.lint': {
    whiteSpace: 'pre'
  }
});